var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ViewChild, ElementRef, Output, EventEmitter } from '@angular/core';
var NgxMaterialDialComponent = /** @class */ (function () {
    function NgxMaterialDialComponent() {
        this.value = 180;
        this.valueChange = new EventEmitter();
    }
    NgxMaterialDialComponent.prototype.onClick = function (e) {
        this.value = this.calcAngle(e.offsetX, e.offsetY);
        this.valueChange.emit(this.value);
        this.redraw();
    };
    NgxMaterialDialComponent.prototype.calcAngle = function (x, y) {
        return Math.round(Math.atan2(y - 50, x - 50) * (180 / Math.PI)) + 90;
    };
    NgxMaterialDialComponent.prototype.redraw = function () {
        this.rootElement.nativeElement.style.transform =
            'rotate(' + this.value + 'deg)';
    };
    NgxMaterialDialComponent.prototype.ngOnInit = function () {
        this.redraw();
    };
    __decorate([
        ViewChild('rootElement'),
        __metadata("design:type", ElementRef)
    ], NgxMaterialDialComponent.prototype, "rootElement", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], NgxMaterialDialComponent.prototype, "value", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], NgxMaterialDialComponent.prototype, "valueChange", void 0);
    NgxMaterialDialComponent = __decorate([
        Component({
            selector: 'ngx-material-dial',
            template: '<div (click)="onClick($event)">\n	<div outer #rootElement>\n		<div inner></div>\n	</div>\n</div>\n',
            styles: [':host {\n    display: block;\n}\n\n:host > div {\n    width: 100%;\n    height: 100%;\n}\n\ndiv[outer] {\n    border: 1px solid #616161;\n    background-color: #DDDDDD;\n    border-radius: 50%;\n    position: relative;\n    pointer-events: none;\n    transition: transform 0.3s;\n    min-width: 100px;\n    min-height: 100px;\n}\n\ndiv[inner] {\n    border: 1px solid #616161;\n    background-color: #AAAAAA;\n    border-radius: 50%;\n    width: 20%;\n    height: 20%;\n    position: absolute;\n    pointer-events: none;\n    top: 10%;\n    left: 40%;\n}\n']
        })
    ], NgxMaterialDialComponent);
    return NgxMaterialDialComponent;
}());
export { NgxMaterialDialComponent };
//# sourceMappingURL=dial.component.js.map